
/**
 * Write a description of class MergeSort here.
 *
 * @author (your name)
 * @version (a version number or a date)
 */
public class MergeSort
{

    private long[] theArray;          // ref to array theArray
    private int nElems;               // number of data items
    //-----------------------------------------------------------
    public MergeSort(int max)            // constructor
    {
        theArray = new long[max];      // create array
        nElems = 0;
    }
    //-----------------------------------------------------------
    public void insert(long value)    // put element into array
    {
        theArray[nElems] = value;      // insert it
        nElems++;                      // increment size
    }
    //-----------------------------------------------------------
    public String toString()             // displays array contents
    {
        String s = "";
        for(int j=0; j<nElems; j++)  // for each element,
            s += theArray[j] + " ";  // display it
        return s;
    }
    //-----------------------------------------------------------
    public void mergeSort()        // called by main()
    {                              // provides workspace
        long[] workSpace = new long[nElems];
        for(int j=0; j<nElems; j++)  // for each element,
            workSpace[j] = theArray[j];
        recursiveMergeSort(workSpace, 0, nElems-1);
    }
    //-----------------------------------------------------------
    private void recursiveMergeSort(long[] workSpace, int lowerBound,
    int upperBound)
    {
        if(lowerBound == upperBound)         // if range is 1,
            return;                          // no use sorting
        else
        {                                    // find midpoint
            int mid = (lowerBound+upperBound) / 2; // integer division
            /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
            /* NOTE:                                                           */
            /* if you want to see the intermediate results, uncomment the      */
            /* line comments below in this recursiveMergeSort method.          */
            /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
            
            // sort low half
            //if (lowerBound != mid) {
                String sLow = "";
                sLow += "sorting lower half of array, midpoint: " + mid + '\n';
                for(int j=lowerBound; j<mid; j++)  // for each element,       
                    sLow += workSpace[j] + " ";
                System.out.println(sLow);
                recursiveMergeSort(workSpace, lowerBound, mid);
            //}
            //if (mid+1 != upperBound) {    
                // sort high half
                String sHigh = "";
                sHigh += "sorting upper half of array, midpoint: " + mid + '\n';
                for(int j=mid+1; j<upperBound; j++)  // for each element,       
                    sHigh += workSpace[j] + " ";
                System.out.println(sHigh);
                recursiveMergeSort(workSpace, mid+1, upperBound);
            //}
            // merge them
            merge(workSpace, lowerBound, mid+1, upperBound);
            System.out.println("Elements after merge: ");
            String ms = "";
            for(int j=0; j<nElems; j++)  // for each element,
                ms += theArray[j] + " ";  // display it       
            System.out.println(ms);

        }  // end else
    }  // end recMergeSort()
    //-----------------------------------------------------------
    private void merge(long[] workSpace, int lowPtr,
    int highPtr, int upperBound)
    {
        int j = 0;                             // workspace index
        int lowerBound = lowPtr;
        int mid = highPtr-1;
        int n = upperBound-lowerBound+1;       // # of items

        while(lowPtr <= mid && highPtr <= upperBound)
            if( theArray[lowPtr] < theArray[highPtr] )
                workSpace[j++] = theArray[lowPtr++];
            else
                workSpace[j++] = theArray[highPtr++];

        while(lowPtr <= mid)
            workSpace[j++] = theArray[lowPtr++];

        while(highPtr <= upperBound)
            workSpace[j++] = theArray[highPtr++];

        for(j=0; j<n; j++)
            theArray[lowerBound+j] = workSpace[j];
    }  // end merge()
    //-----------------------------------------------------------

    public static void main(String[] args)
    {
        int maxSize = 100;             // array size
        MergeSort msArray;                    // reference to array
        msArray = new MergeSort(maxSize);     // create the array

        msArray.insert(64);                // insert items
        msArray.insert(21);
        msArray.insert(33);
        msArray.insert(70);
        msArray.insert(12);
        msArray.insert(85);
        msArray.insert(44);
        msArray.insert(3);
        msArray.insert(99);
        msArray.insert(1);
        msArray.insert(108);
        msArray.insert(36);

        System.out.println("Unsorted elements: ");
        System.out.println(msArray);
        msArray.mergeSort();               // merge sort the array
        System.out.println("After merge sort: ");
        System.out.println(msArray);      

    }  // end main()
}
